Freeciv-3.3: /fast/freeciv/nightly/main/client/gui-gtk-3.22/gui_stuff.h File Reference

Freeciv-3.3

Loading...
Searching...
No Matches
Data Structures | Macros | Typedefs | Enumerations | Functions
gui_stuff.h File Reference
`#include <gtk/gtk.h>`
`#include "shared.h"`

Go to the source code of this file.

## Data Structures

struct | ITree
struct | gui_dialog

## Macros

#define | TREE_ITER_PTR(x) (&(x).it)

## Typedefs

typedef void(* | GUI_DIALOG_RESPONSE_FUN) (struct gui_dialog *, int, gpointer)

## Enumerations

enum | gui_dialog_type { GUI_DIALOG_WINDOW , GUI_DIALOG_TAB }

## Functions

GtkWidget * | icon_label_button_new (const gchar *icon_name, const gchar *label_text)
void | gtk_stockbutton_set_label (GtkWidget *button, const gchar *label_text)
void | gtk_expose_now (GtkWidget *w)
void | set_relative_window_position (GtkWindow *ref, GtkWindow *w, int px, int py)
void | intl_slist (int n, const char **s, bool *done)
void | itree_begin (GtkTreeModel *model, ITree *it)
gboolean | itree_end (ITree *it)
void | itree_next (ITree *it)
void | itree_get (ITree *it,...)
void | itree_set (ITree *it,...)
void | tstore_append (GtkTreeStore *store, ITree *it, ITree *parent)
gboolean | itree_is_selected (GtkTreeSelection *selection, ITree *it)
void | itree_select (GtkTreeSelection *selection, ITree *it)
void | itree_unselect (GtkTreeSelection *selection, ITree *it)
gint | gtk_tree_selection_get_row (GtkTreeSelection *selection)
void | gtk_tree_view_focus (GtkTreeView *view)
void | setup_dialog (GtkWidget *shell, GtkWidget *parent)
GtkTreeViewColumn * | add_treeview_column (GtkWidget *view, const char *title, GType gtype, int model_index)
GtkWidget * | gtk_aux_menu_bar_new (void)
void | dlg_tab_provider_prepare (void)
void | gui_dialog_new (struct gui_dialog **pdlg, GtkNotebook *notebook, gpointer user_data, bool check_top)
void | gui_dialog_set_default_response (struct gui_dialog *dlg, int response)
GtkWidget * | gui_dialog_add_button (struct gui_dialog *dlg, const char *icon_name, const char *text, int response)
GtkWidget * | gui_dialog_add_widget (struct gui_dialog *dlg, GtkWidget *widget)
void | gui_dialog_set_default_size (struct gui_dialog *dlg, int width, int height)
void | gui_dialog_set_title (struct gui_dialog *dlg, const char *title)
void | gui_dialog_set_response_sensitive (struct gui_dialog *dlg, int response, bool setting)
void | gui_dialog_show_all (struct gui_dialog *dlg)
void | gui_dialog_present (struct gui_dialog *dlg)
void | gui_dialog_raise (struct gui_dialog *dlg)
void | gui_dialog_alert (struct gui_dialog *dlg)
void | gui_dialog_destroy (struct gui_dialog *dlg)
void | gui_dialog_destroy_all (void)
GtkWidget * | gui_dialog_get_toplevel (struct gui_dialog *dlg)
void | gui_dialog_response_set_callback (struct gui_dialog *dlg, GUI_DIALOG_RESPONSE_FUN fun)
void | gui_dialog_set_return_dialog (struct gui_dialog *dlg, struct gui_dialog *return_dialog)
void | gui_update_font_full (const char *font_name, const char *font_value, PangoFontDescription **font_desc)
void | disable_gobject_callback (GObject *obj, GCallback cb)
void | enable_gobject_callback (GObject *obj, GCallback cb)

## Macro Definition Documentation

## ◆ TREE_ITER_PTR

#define TREE_ITER_PTR | ( |  | x | ) | (&(x).it)

Definition at line 38 of file gui_stuff.h.

## Typedef Documentation

## ◆ GUI_DIALOG_RESPONSE_FUN

typedef void(* GUI_DIALOG_RESPONSE_FUN) (struct gui_dialog *, int, gpointer)

Definition at line 67 of file gui_stuff.h.

## Enumeration Type Documentation

## ◆ gui_dialog_type

enum gui_dialog_type

Enumerator
GUI_DIALOG_WINDOW |
GUI_DIALOG_TAB |

Definition at line 60 of file gui_stuff.h.

## Function Documentation

## ◆ add_treeview_column()

GtkTreeViewColumn * add_treeview_column | ( | GtkWidget * | view,
|  | const char * | title,
|  | GType | gtype,
|  | int | model_index
| ) |  |

Convenience function to add a column to a GtkTreeView. Returns the added column, or NULL if an error occurred.

Definition at line 1123 of file gui_stuff.c.

## ◆ disable_gobject_callback()

void disable_gobject_callback | ( | GObject * | obj,
|  | GCallback | cb
| ) |  |

Temporarily disable signal invocation of the given callback for the given GObject. Re-enable the signal with enable_gobject_callback.

Definition at line 1090 of file gui_stuff.c.

## ◆ dlg_tab_provider_prepare()

void dlg_tab_provider_prepare | ( | void |  | ) |

Prepare dialog tab style provider.

Definition at line 1155 of file gui_stuff.c.

## ◆ enable_gobject_callback()

void enable_gobject_callback | ( | GObject * | obj,
|  | GCallback | cb
| ) |  |

Re-enable a signal callback blocked by disable_gobject_callback.

Definition at line 1106 of file gui_stuff.c.

## ◆ gtk_aux_menu_bar_new()

GtkWidget * gtk_aux_menu_bar_new | ( | void |  | ) |

Create an auxiliary menubar (i.e., not the main menubar at the top of the window).

Definition at line 255 of file gui_stuff.c.

Referenced by create_city_report_menubar(), create_diplomacy_dialog(), create_players_dialog(), and create_worklist().

## ◆ gtk_expose_now()

void gtk_expose_now | ( | GtkWidget * | w | ) |

Draw widget now

Definition at line 52 of file gui_stuff.c.

## ◆ gtk_stockbutton_set_label()

void gtk_stockbutton_set_label | ( | GtkWidget * | button,
|  | const gchar * | label_text
| ) |  |

Changes the label (with mnemonic) on an existing stockbutton. See gtk_stockbutton_new.

Changes the label (with mnemonic) on an existing stockbutton. See gtk_stockbutton_new().

Definition at line 96 of file gui_stuff.c.

## ◆ gtk_tree_selection_get_row()

gint gtk_tree_selection_get_row | ( | GtkTreeSelection * | selection | ) |

Return the selected row in a GtkTreeSelection. If no row is selected return -1.

Definition at line 215 of file gui_stuff.c.

## ◆ gtk_tree_view_focus()

void gtk_tree_view_focus | ( | GtkTreeView * | view | ) |

Give focus to view

Definition at line 236 of file gui_stuff.c.

## ◆ gui_dialog_add_button()

GtkWidget * gui_dialog_add_button | ( | struct gui_dialog * | dlg,
|  | const char * | icon_name,
|  | const char * | text,
|  | int | response
| ) |  |

Adds a button to a dialog.

Definition at line 706 of file gui_stuff.c.

## ◆ gui_dialog_add_widget()

GtkWidget * gui_dialog_add_widget | ( | struct gui_dialog * | dlg,
|  | GtkWidget * | widget
| ) |  |

Adds a widget to a dialog.

Definition at line 722 of file gui_stuff.c.

Referenced by create_city_report_dialog(), and create_players_dialog().

## ◆ gui_dialog_alert()

void gui_dialog_alert | ( | struct gui_dialog * | dlg | ) |

Alert the user to an important event.

Definition at line 888 of file gui_stuff.c.

## ◆ gui_dialog_destroy()

void gui_dialog_destroy | ( | struct gui_dialog * | dlg | ) |

Destroy a dialog.

Definition at line 954 of file gui_stuff.c.

## ◆ gui_dialog_destroy_all()

void gui_dialog_destroy_all | ( | void |  | ) |

Destroy all dialogs.

Definition at line 974 of file gui_stuff.c.

## ◆ gui_dialog_get_toplevel()

GtkWidget * gui_dialog_get_toplevel | ( | struct gui_dialog * | dlg | ) |

Get the dialog's toplevel window.

Definition at line 787 of file gui_stuff.c.

## ◆ gui_dialog_new()

void gui_dialog_new | ( | struct gui_dialog ** | pdlg,
|  | GtkNotebook * | notebook,
|  | gpointer | user_data,
|  | bool | check_top
| ) |  |

Creates a new dialog. It will be a tab or a window depending on the current user setting of 'enable_tabs' gtk-gui option. Sets pdlg to point to the dialog once it is create, Zeroes pdlg on dialog destruction. user_data will be passed through response function check_top indicates if the layout decision should depend on the parent.

Definition at line 517 of file gui_stuff.c.

## ◆ gui_dialog_present()

void gui_dialog_present | ( | struct gui_dialog * | dlg | ) |

Notify the user the dialog has changed.

Definition at line 835 of file gui_stuff.c.

## ◆ gui_dialog_raise()

void gui_dialog_raise | ( | struct gui_dialog * | dlg | ) |

Raise dialog to top.

Definition at line 865 of file gui_stuff.c.

## ◆ gui_dialog_response_set_callback()

void gui_dialog_response_set_callback | ( | struct gui_dialog * | dlg,
|  | GUI_DIALOG_RESPONSE_FUN | fun
| ) |  |

Set the response callback for a dialog.

Definition at line 988 of file gui_stuff.c.

## ◆ gui_dialog_set_default_response()

void gui_dialog_set_default_response | ( | struct gui_dialog * | dlg,
|  | int | response
| ) |  |

Changes the default dialog response.

Definition at line 734 of file gui_stuff.c.

Referenced by create_city_report_dialog(), create_diplomacy_dialog(), create_players_dialog(), diplomacy_main_create(), economy_report_init(), popup_find_dialog(), popup_notify_dialog(), science_report_init(), and units_report_init().

## ◆ gui_dialog_set_default_size()

void gui_dialog_set_default_size | ( | struct gui_dialog * | dlg,
|  | int | width,
|  | int | height
| ) |  |

Sets the dialog's default size (applies to toplevel windows only).

Definition at line 919 of file gui_stuff.c.

## ◆ gui_dialog_set_response_sensitive()

void gui_dialog_set_response_sensitive | ( | struct gui_dialog * | dlg,
|  | int | response,
|  | bool | setting
| ) |  |

Change the sensitivity of a dialog button.

Definition at line 760 of file gui_stuff.c.

## ◆ gui_dialog_set_return_dialog()

void gui_dialog_set_return_dialog | ( | struct gui_dialog * | dlg,
|  | struct gui_dialog * | return_dialog
| ) |  |

When the dlg dialog is destroyed the return_dialog will be raised

Definition at line 997 of file gui_stuff.c.

## ◆ gui_dialog_set_title()

void gui_dialog_set_title | ( | struct gui_dialog * | dlg,
|  | const char * | title
| ) |  |

Changes a dialog's title.

Definition at line 935 of file gui_stuff.c.

## ◆ gui_dialog_show_all()

void gui_dialog_show_all | ( | struct gui_dialog * | dlg | ) |

Show the dialog contents, but not the dialog per se.

Definition at line 795 of file gui_stuff.c.

## ◆ gui_update_font_full()

void gui_update_font_full | ( | const char * | font_name,
|  | const char * | font_value,
|  | PangoFontDescription ** | font_desc
| ) |  |

Update a font option which is not attached to a widget.

Definition at line 1073 of file gui_stuff.c.

## ◆ icon_label_button_new()

GtkWidget * icon_label_button_new | ( | const gchar * | icon_name,
|  | const gchar * | label_text
| ) |  |

Create new icon button with label

Create new icon button with label.

Current implementation sets either icon or label, preferring label, never both. Caller should not rely on that, though.

Definition at line 76 of file gui_stuff.c.

## ◆ intl_slist()

void intl_slist | ( | int | n,
|  | const char ** | s,
|  | bool * | done
| ) |  |

Returns gettext-converted list of n strings. The individual strings in the list are as returned by gettext(). In case of no NLS, the strings will be the original strings, so caller should ensure that the originals persist for as long as required. (For no NLS, still allocate the list, for consistency.)

(This is not directly gui/gtk related, but it fits in here because so far it is used for doing i18n for gtk titles...)

Definition at line 111 of file gui_stuff.c.

## ◆ itree_begin()

void itree_begin | ( | GtkTreeModel * | model,
|  | ITree * | it
| ) |  |

Set itree to the beginning

Definition at line 127 of file gui_stuff.c.

## ◆ itree_end()

gboolean itree_end | ( | ITree * | it | ) |

Return whether itree end has been reached

Definition at line 136 of file gui_stuff.c.

## ◆ itree_get()

void itree_get | ( | ITree * | it,
|  |  | ...
| ) |  |

Get values from itree

Definition at line 164 of file gui_stuff.c.

## ◆ itree_is_selected()

gboolean itree_is_selected | ( | GtkTreeSelection * | selection,
|  | ITree * | it
| ) |  |

Return whether current itree item is selected

Definition at line 190 of file gui_stuff.c.

## ◆ itree_next()

void itree_next | ( | ITree * | it | ) |

Make itree to go forward one step

Definition at line 144 of file gui_stuff.c.

## ◆ itree_select()

void itree_select | ( | GtkTreeSelection * | selection,
|  | ITree * | it
| ) |  |

Add current itree item to selection

Definition at line 198 of file gui_stuff.c.

## ◆ itree_set()

void itree_set | ( | ITree * | it,
|  |  | ...
| ) |  |

Store values to itree

Definition at line 152 of file gui_stuff.c.

## ◆ itree_unselect()

void itree_unselect | ( | GtkTreeSelection * | selection,
|  | ITree * | it
| ) |  |

Remove current itree item from selection

Definition at line 206 of file gui_stuff.c.

## ◆ set_relative_window_position()

void set_relative_window_position | ( | GtkWindow * | ref,
|  | GtkWindow * | w,
|  | int | px,
|  | int | py
| ) |  |

Set window position relative to reference window

Definition at line 60 of file gui_stuff.c.

Referenced by popup_help_dialog_typed().

## ◆ setup_dialog()

void setup_dialog | ( | GtkWidget * | shell,
|  | GtkWidget * | parent
| ) |  |

This function handles new windows which are subwindows to the toplevel window. It must be called on every dialog in the game, so fullscreen windows are handled properly by the window manager.

Definition at line 287 of file gui_stuff.c.

## ◆ tstore_append()

void tstore_append | ( | GtkTreeStore * | store,
|  | ITree * | it,
|  | ITree * | parent
| ) |  |

Append one item to the end of tree store

Definition at line 176 of file gui_stuff.c.